<CASM name="megaman">
  <state name="readyWait" looping="true">
    <transition nextstate="teleport" trigger="teleport" triggerVal="1"/>
    <signal name="canMove" intValue=0 time=0 /> 
  </state>
  <state name="teleport" anim="megamanTeleport" looping="false">
    <transition nextstate="idle" trigger="always"/>
    <signal name="canMove" intValue=1 time=-1 /> 
    <signal name="playSound" strValue="teleport" time=-1 /> 
  </state>
  <state name="idle" anim="megamanIdle" looping="true">
    <transition nextstate="runningStart" trigger="move" triggerVal="1"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="idleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>

    <transition nextstate="teleport" trigger="teleport" triggerVal="1"/>
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
  </state>
  <state name="runningStart" anim="megamanRunStart">
    <transition nextstate="idle" trigger="move" triggerVal="0"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="runningShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="running" trigger="always"/>
    <signal name="forceMoveX" intValue=1 time=33 /> 
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
  </state>  
  <state name="running" anim="megamanRun" looping="true">
    <transition nextstate="runningEnd" trigger="move" triggerVal="0"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="runningShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
  </state>
  <state name="runningEnd" anim="megamanRunEnd">
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="idleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="idle" trigger="always"/>
    <signal name="forceMoveX" intValue=2 time=0 /> 
    <signal name="forceMoveX" intValue=2 time=33 /> 
    <signal name="forceMoveX" intValue=2 time=67 /> 
    <signal name="forceMoveX" intValue=1 time=100 /> 
    <signal name="forceMoveX" intValue=1 time=133 /> 
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
  </state>  
  
  <state name="jumping" anim="megamanJump" looping="true">
    <transition nextstate="idle" trigger="hitGround" triggerVal="1"/>
    <transition nextstate="running" trigger="hitGround" triggerVal="2"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="jumpingShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
  </state>
  
  <state name="climbing" anim="megamanClimb" looping="true">
    <transition nextstate="climbIdle" trigger="move" triggerVal="0"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="idle" trigger="hitGround" triggerVal="1"/>
    <transition nextstate="idle" trigger="climb" triggerVal="-1"/>
    <transition nextstate="climbIdleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
  </state>
  <state name="climbIdle" anim="megamanClimbIdle">
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="idle" trigger="climb" triggerVal="-1"/>
    <transition nextstate="climbIdleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
  </state>
  <state name="climbInto" anim="megamanClimbInto" looping="true">
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="idle" trigger="hitGround" triggerVal="1"/>
    <transition nextstate="idle" trigger="climb" triggerVal="-1"/>
    <transition nextstate="climbIdle" trigger="move" triggerVal="0"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbIdleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
  </state>
  
  <state name="idleShoot" anim="megamanIdleShoot">
    <transition nextstate="runningShootStart" trigger="move" triggerVal="1"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="idleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="idle" trigger="always"/>

    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
    <signal name="playSound" strValue="megashoot" time=0 /> 
  </state>
    <state name="runningShootStart" anim="megamanRunShootStart">
    <transition nextstate="idle" trigger="move" triggerVal="0"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="running" trigger="always"/>
    <signal name="forceMoveX" intValue=1 time=33 /> 
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
  </state>  
  <state name="runningShoot" anim="megamanRunShoot">
    <transition nextstate="runningShootEnd" trigger="move" triggerVal="0"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="running" trigger="always"/>
    <signal name="playSound" strValue="megashoot" time=0 /> 
  </state>
  <state name="runningShootEnd" anim="megamanRunShootEnd">
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="idle" trigger="always"/>
    <signal name="forceMoveX" intValue=2 time=0 /> 
    <signal name="forceMoveX" intValue=2 time=33 /> 
    <signal name="forceMoveX" intValue=2 time=67 /> 
    <signal name="forceMoveX" intValue=1 time=100 /> 
    <signal name="forceMoveX" intValue=1 time=133 /> 
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
  </state>  
  <state name="jumpingShoot" anim="megamanJumpShoot">
    <transition nextstate="idle" trigger="hitGround" triggerVal="1"/>
    <transition nextstate="running" trigger="hitGround" triggerVal="2"/>
    <transition nextstate="climbing" trigger="climb" triggerVal="1"/>
    <transition nextstate="climbInto" trigger="climb" triggerVal="2"/>
    <transition nextstate="jumpingShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="jumping" trigger="always"/>
    <signal name="playSound" strValue="megashoot" time=0 /> 
  </state>
  <state name="climbIdleShoot" anim="megamanClimbIdleShoot">
    <transition nextstate="climbIdleShoot" trigger="shoot" triggerVal="1"/>
    <transition nextstate="jumping" trigger="jump" triggerVal="1"/>
    <transition nextstate="hitReact" trigger="hit" triggerVal="1"/>
    <transition nextstate="climbIdle" trigger="always"/>
    <signal name="inMoveState" intValue=0 time=0 /> 
    <signal name="inMoveState" intValue=1 time=-1 /> 
    <signal name="playSound" strValue="megashoot" time=0 /> 
  </state>
  
  <state name="hitReact" anim="megamanHitReact">
    <transition nextstate="idle" trigger="always"/>
    <signal name="canMove" intValue=0 time=0 /> 
    <signal name="canMove" intValue=1 time=-1 /> 
    <signal name="renderFlash" intValue=1867 time=0 /> 
    <signal name="temporaryInvincibility" intValue=1867 time=0 /> 
    <signal name="forceMoveX" intValue=-1 time=33 /> 
    <signal name="forceMoveX" intValue=-1 time=67 /> 
    <signal name="forceMoveX" intValue=-1 time=100 /> 
    <signal name="forceMoveX" intValue=-1 time=133 /> 
    <signal name="forceMoveX" intValue=-1 time=167 /> 
    <signal name="forceMoveX" intValue=-1 time=200 /> 
    <signal name="forceMoveX" intValue=-1 time=233 /> 
    <signal name="forceMoveX" intValue=-1 time=267 /> 
    <signal name="forceMoveX" intValue=-1 time=300 /> 
    <signal name="forceMoveX" intValue=-1 time=330 /> 
    <signal name="forceMoveX" intValue=-1 time=367 /> 
    <signal name="forceMoveX" intValue=-1 time=400 /> 
    <signal name="forceMoveX" intValue=-1 time=433 /> 
    <signal name="forceMoveX" intValue=-1 time=467 /> 
    
    <signal name="spawnEffect" strValue="megamanHit" time=0 />   
    <signal name="playSound" strValue="megahit" time=0 />  
  </state>
</CASM>
